#include "CoRoutine.h"
#include <stdio.h>
#include <assert.h>
#include <string.h>


void CoRoutineMain_0(routineProcedure* a_pProc)
{
    for(int i=0; i<10; i++)
        {
        printf("I'm routine 1 - %d\n", i);
        PAUSE(1000);
        }
}

void CoRoutineMain_1(routineProcedure* a_pProc)
{
    for(int i=0; i<5; i++)
        {
        PAUSE(2000);
        printf("***** Routine 2 *****\n");        
        }
}

void CoRoutineMain_Test(routineProcedure* a_pProc)
{
    for(int i=0; i<15; i++)
        {        
        PAUSE(0);
        }
}


/*******************************************
Main Program
*******************************************/
int main(int argc, char* argv[])
{
    static const int NUM_COROUTINES_MAX      = 20000;
    static const int FAKE_MSEC_TIME_PER_LOOP = 1;    

    static routineProcedure m_Procedures[NUM_COROUTINES_MAX]; // Staticly creately 1000 Available co-routines
   
    // Initialize all to zero
    memset(&m_Procedures, 0, sizeof(m_Procedures));

    // Start off two routines initially
    StartRoutine(&m_Procedures[0], CoRoutineMain_0);
    StartRoutine(&m_Procedures[1], CoRoutineMain_1);
    int NumCoroutines = 2;

// Uncomment to run through a test of 20,000 co-routines
//    for (int i=0; i<NUM_COROUTINES_MAX; i++)
//        {
//        StartRoutine(&m_Procedures[i], CoRoutineMain_Test);
//        }
//    NumCoroutines = NUM_COROUTINES_MAX;


    while (1) // Run-ForEver or whenver control-c is hit
    {
        bool allDone = true;

        // Give CPU time to all actively running routines.. 
        for (int i=0; i<NumCoroutines; i++)
            {
            if (m_Procedures[i].m_RunState == routineProcedure::RS_INVALID)
                continue;

            allDone = false;
            if (m_Procedures[i].m_PauseTime > 0)
                {
                m_Procedures[i].m_PauseTime -= FAKE_MSEC_TIME_PER_LOOP;
                }
            else
                {                
                ProcessRoutine(&(m_Procedures[i]));
                }
            }

        if (allDone == true)
            break;            
    }

    printf("Scripts are all done!\n");
	return 0;
}

