#include "CoRoutine.h"
#include <string.h>

/************************************
Start Routine -
************************************/
void StartRoutine(routineProcedure* a_pRoutine, PF_RPMAIN   a_pFunction)
{
    static jmp_buf m_ExecSystem;
    a_pRoutine->m_RunState      = routineProcedure::RS_START;
    a_pRoutine->m_pFunction     = a_pFunction;
    a_pRoutine->m_pExecSystem   = &m_ExecSystem;
}

/************************************
Process Routine -
************************************/
void ProcessRoutine(routineProcedure* a_pRoutine)
{
    volatile int stack;

    // Mark where are current stack pointer is at
    TG_SAVE_STACK(stack);
    a_pRoutine->m_StackBegin = stack;

    if (setjmp(*(a_pRoutine->m_pExecSystem)) == 0) 
        {
        if (a_pRoutine->m_RunState == routineProcedure::RS_START)   // New script, spawn
            {
            a_pRoutine->m_RunState = routineProcedure::RS_RUN;
            a_pRoutine->m_pFunction(a_pRoutine);
            a_pRoutine->m_RunState = routineProcedure::RS_INVALID;
            return;
            }
        else                    // old script, continue
            {
            stack = a_pRoutine->m_StackUsed;
            TG_RESTORE_STACK;
            TG_SAVE_STACK(stack);

            // Copy contents of stack for long jumping forward.
            memcpy((char*)(stack), a_pRoutine->m_Stack, a_pRoutine->m_StackUsed);
            longjmp(a_pRoutine->m_pExecCurrent, 1);
            }
        }
}
